/*<---------------------------------------------------------------------->*/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "chrtbl_option.h"
#include "chrtbl_err.h"
/*<---------------------------------------------------------------------->*/
/* Ë̎YB */
static void get_option_value(chrtbl_option_t *option, const char *key, const char *value)
{
	if(!strcmp("TextFile", key)){
		if(option->textfile_count >= CHRTBL_OPTION_TEXTFILE_MAX){
			print_err("too many textfiles. (max %d)", CHRTBL_OPTION_TEXTFILE_MAX);
			return;
		}
		strcpy(option->textfile[option->textfile_count], value);
		option->textfile_count++;
	}
	else if(!strcmp("ImageFile", key)){
		strcpy(option->imagefile, value);
	}
	else if(!strcmp("Width", key)){
		sscanf(value, "%d", &option->width);
	}
	else if(!strcmp("Height", key)){
		sscanf(value, "%d", &option->height);
	}
	else if(!strcmp("FontName", key)){
		strcpy(option->fontname, value);
	}
	else if(!strcmp("FontSize", key)){
		sscanf(value, "%d", &option->fontsize);
	}
	else if(!strcmp("CharWidth", key)){
		sscanf(value, "%d", &option->char_width);
	}
	else if(!strcmp("CharHeight", key)){
		sscanf(value, "%d", &option->char_height);
	}
	else if(!strcmp("CharListFile_Text", key)){
		strcpy(option->charlistfile_text, value);
	}
	else if(!strcmp("CharListFile_Binary", key)){
		strcpy(option->charlistfile_binary, value);
	}
}
/*<---------------------------------------------------------------------->*/
/* ݒt@Cǂݍō\̂ɓB */
int get_chrtbl_option(const char *file, chrtbl_option_t *option)
{
	FILE *fp;
	char buf[1024];
	char key[1024], value[1024], *p;

	memset(option, 0, sizeof *option);

	fp = fopen(file,"r");
	if(!fp){
		return -1;
	}

	/* key  value |C^ɂ buf wB */
	while(fgets(buf, sizeof(buf), fp) != NULL){
		p = strchr(buf, '\n');
		if(p != NULL){
			*p = '\0';
		}
		p = strchr(buf, '=');
		/* '='ΖB */
		if(p == NULL)
			continue;
		/* '='̌ɑp󔒂Ƃ΂B */
		p++;
		while((*p) == ' '){
			p++;
		}
		/* l̕ɕʂB */
		strcpy(value, p);

		/* L[̕ɕʂB */
		strcpy(key, buf);
		p = strchr(key, ' ');
		if(p == NULL){
			p = strchr(key, '=');
		}
		/* ΂肦ȂꉞB */
		if(p == NULL)
			continue;
		/* '='܂'='̑O̔p󔒂̒O܂łL[̕ƂB */
		*p = '\0';

		get_option_value(option, key, value);
	}
	fclose(fp);
	return 0;
}
/*<---------------------------------------------------------------------->*/
